﻿using System;
using Com.Multisoft.Drivers.Fiscalcore;

namespace ConnectionExample
{
    public class ExceptionCallback : IExceptionCallbackStub
    {
        private const int UnInit = -1;
        public int Err { get; private set; }
        public string Msg {  get; private set; }
        public int ExtErr { get; private set; }
        public string Stack { get; private set; }

        public ExceptionCallback()
        {
            Err = UnInit;
        }

        public override void HandleException(int errCode, string message, int extErrCode, string stackTrace)
        {
            Stack = stackTrace;
            ExtErr = extErrCode;
            Msg = message;
            Err = errCode;
        }

        public void Complete()
        {
            if (Err != UnInit)
            {
                Exception e = new Exception(Msg);
                throw e;
            }
        }
    }
}