﻿using System.Threading;
using Android.Content;
using Android.OS;
using Android.Widget;
using Com.Multisoft.Drivers.Fiscalcore;

namespace ConnectionExample
{
    public class FiscalCoreServiceConnection : Java.Lang.Object, IServiceConnection
    {
        private static ManualResetEvent _isConnected;
        public IFiscalCore Core { get; private set; }
        public FiscalCoreServiceConnection()
        {
            _isConnected = new ManualResetEvent(false);
        }

        public void OnServiceConnected(ComponentName name, IBinder service)
        {
            Core = IFiscalCoreStub.AsInterface(service);
            while(!Core.IsReady())
                Thread.Sleep(100);
            var context = Android.App.Application.Context;
            var message = context.Resources.GetString(Resource.String.serviceIsReady);

            Toast.MakeText(context, message, ToastLength.Long);
            _isConnected.Set();
        }

        public void OnServiceDisconnected(ComponentName name)
        {
            _isConnected.Reset();
            Core = null;
        }

        public ManualResetEvent GetConnected()
        {
            return _isConnected;
        }
    }
}